package jalview.appletgui;

import jalview.datamodel.*;
import jalview.analysis.*;
import jalview.schemes.*;
import java.awt.*;
import java.awt.event.*;

public class APopupMenu extends java.awt.PopupMenu
{
  Menu groupMenu = new Menu();
  Menu analyze = new Menu();
  Menu defineMenu = new Menu();
  Menu groupName = new Menu();
  Menu groupAnnotation = new Menu();
  protected MenuItem clustalColour = new MenuItem();
  protected MenuItem zappoColour = new MenuItem();
  protected MenuItem taylorColour = new MenuItem();
  protected MenuItem hydrophobicityColour = new MenuItem();
  protected MenuItem helixColour = new MenuItem();
  protected MenuItem strandColour = new MenuItem();
  protected MenuItem turnColour = new MenuItem();
  protected MenuItem buriedColour = new MenuItem();
  protected CheckboxMenuItem abovePIDColour = new CheckboxMenuItem();
  protected MenuItem userDefinedColour = new MenuItem();
  protected MenuItem PIDColour = new MenuItem();
  protected MenuItem BLOSUM62Colour = new MenuItem();
  MenuItem noColourmenuItem = new MenuItem();
  protected CheckboxMenuItem conservationMenuItem = new CheckboxMenuItem();


  AlignmentPanel ap;
  Menu sequenceMenu = new Menu();
  MenuItem sequenceName = new MenuItem();
  Menu residueMenu = new Menu();
  MenuItem annotateResidue = new MenuItem();

  Sequence sequence;
  MenuItem unGroupMenuItem = new MenuItem();
  MenuItem outline = new MenuItem();
  MenuItem nucleotideMenuItem = new MenuItem();

  public APopupMenu(AlignmentPanel ap, Sequence seq)
  {
    ///////////////////////////////////////////////////////////
    // If this is activated from the sequence panel, the user may want to
    // edit or annotate a particular residue. Therefore display the residue menu
    //
    // If from the IDPanel, we must display the sequence menu
    //////////////////////////////////////////////////////////

    this.ap = ap;
    sequence = seq;

    try
    {     jbInit();   }
    catch(Exception e)
    {    e.printStackTrace();    }


    if(seq!=null)
      residueMenu.setEnabled(false);
    else
      sequenceMenu.setEnabled(false);

  }
  private void jbInit() throws Exception
  {
    groupMenu.setLabel("Group");
    analyze.setLabel("Analyze");
    analyze.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        analyze_actionPerformed(e);
      }
    });
    defineMenu.setLabel("Define");
    groupName.setLabel("Name");
    groupName.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        groupName_actionPerformed(e);
      }
    });
    groupAnnotation.setEnabled(false);
    groupAnnotation.setLabel("Annotation");
    groupAnnotation.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        groupAnnotation_actionPerformed(e);
      }
    });
    sequenceMenu.setLabel("Sequence");
    sequenceName.setLabel("Edit name");
    sequenceName.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        sequenceName_actionPerformed(e);
      }
    });
    residueMenu.setLabel("Residue");
    annotateResidue.setEnabled(false);
    annotateResidue.setActionCommand("annotate residue");
    annotateResidue.setLabel("annotate residue???");
    unGroupMenuItem.setLabel("Remove Group");
    unGroupMenuItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        unGroupMenuItem_actionPerformed(e);
      }
    });

    outline.setLabel("Border colour");
    outline.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        outline_actionPerformed(e);
      }
    });
    nucleotideMenuItem.setLabel("Nucleotide");
    nucleotideMenuItem.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        nucleotideMenuItem_actionPerformed(e);
      }
    });

    add(groupMenu);
    this.add(sequenceMenu);
    this.add(residueMenu);
    groupMenu.add(defineMenu);
    groupMenu.add(unGroupMenuItem);
    groupMenu.addSeparator();
    groupMenu.add(analyze);
    defineMenu.add(groupName);
    defineMenu.add(groupAnnotation);
    defineMenu.addSeparator();
    defineMenu.add(outline);
    defineMenu.addSeparator();
    defineMenu.add(noColourmenuItem);
    defineMenu.add(clustalColour);
    defineMenu.add(BLOSUM62Colour);
    defineMenu.add(PIDColour);

    defineMenu.add(zappoColour);
    defineMenu.add(taylorColour);
    defineMenu.add(hydrophobicityColour);
    defineMenu.add(helixColour);
    defineMenu.add(strandColour);
    defineMenu.add(turnColour);
    defineMenu.add(buriedColour);
    defineMenu.add(nucleotideMenuItem);

    defineMenu.add(userDefinedColour);

    defineMenu.addSeparator();
    defineMenu.add(abovePIDColour);
    defineMenu.add(conservationMenuItem);

    sequenceMenu.add(sequenceName);
    residueMenu.add(annotateResidue);

    noColourmenuItem.setLabel("None");
    noColourmenuItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        noColourmenuItem_actionPerformed(e);
      }
    });

    clustalColour.setLabel("Clustalx colours");
    clustalColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        clustalColour_actionPerformed(e);
      }
    });
    zappoColour.setLabel("Zappo");
    zappoColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        zappoColour_actionPerformed(e);
      }
    });
    taylorColour.setLabel("Taylor");
    taylorColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        taylorColour_actionPerformed(e);
      }
    });
    hydrophobicityColour.setLabel("Hydrophobicity");
    hydrophobicityColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        hydrophobicityColour_actionPerformed(e);
      }
    });
    helixColour.setLabel("Helix propensity");
    helixColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        helixColour_actionPerformed(e);
      }
    });
    strandColour.setLabel("Strand propensity");
    strandColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        strandColour_actionPerformed(e);
      }
    });
    turnColour.setLabel("Turn propensity");
    turnColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        turnColour_actionPerformed(e);
      }
    });
    buriedColour.setLabel("Buried Index");
    buriedColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        buriedColour_actionPerformed(e);
      }
    });
    abovePIDColour.setLabel("Above % Identity");
    abovePIDColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        abovePIDColour_actionPerformed(e);
      }
    });
    userDefinedColour.setLabel("User Defined");
    userDefinedColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        userDefinedColour_actionPerformed(e);
      }
    });
    PIDColour.setLabel("Percentage Identity");
    PIDColour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        PIDColour_actionPerformed(e);
      }
    });
    BLOSUM62Colour.setLabel("BLOSUM62");
    BLOSUM62Colour.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        BLOSUM62Colour_actionPerformed(e);
      }
    });
    conservationMenuItem.setLabel("Conservation");
   conservationMenuItem.addActionListener(new java.awt.event.ActionListener()
   {
     public void actionPerformed(ActionEvent e)
     {
       conservationMenuItem_actionPerformed(e);
     }
   });



  }

  void refresh()
  {
    SequenceGroup sg = getGroup();
    SuperGroup superG = ap.av.alignment.getSuperGroup( sg );
    if( superG !=null)
      superG.setSuperGroupProperties( sg );

    ap.seqPanel.repaint();
  }

  protected void clustalColour_actionPerformed(ActionEvent e)
  {
    SequenceGroup sg = getGroup();
    sg.cs = new ClustalxColourScheme(sg.sequences, ap.av.alignment.getWidth());
    refresh();
  }

  protected void zappoColour_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new ZappoColourScheme();
    refresh();
  }

  protected void taylorColour_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new TaylorColourScheme();
    refresh();
  }


  protected void hydrophobicityColour_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new HydrophobicColourScheme();
    refresh();
  }

  protected void helixColour_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new HelixColourScheme();
    refresh();
  }

  protected void strandColour_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new StrandColourScheme();
    refresh();
  }

  protected void turnColour_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new TurnColourScheme();
    refresh();
  }

  protected void buriedColour_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new BuriedColourScheme();
    refresh();
  }

  public void nucleotideMenuItem_actionPerformed(ActionEvent e)
  {
    getGroup().cs = new NucleotideColourScheme();
    refresh();
  }



  protected void abovePIDColour_actionPerformed(ActionEvent e)
  {
    SequenceGroup sg = getGroup();
    if (abovePIDColour.getState())
    {
      sg.cs.setConsensus(AAFrequency.calculate(sg.sequences, 0,
                                               ap.av.alignment.getWidth()));
      int threshold = SliderPanel.setPIDSliderSource(ap, sg.cs, getGroup().getName());
      if (sg.cs instanceof ResidueColourScheme)
        ( (ResidueColourScheme)sg. cs).setThreshold(threshold);
      else if (sg.cs instanceof ScoreColourScheme)
        ( (ScoreColourScheme) sg.cs).setThreshold(threshold);

      SliderPanel.showPIDSlider();


    }
    else // remove PIDColouring
    {
      ResidueColourScheme rcs = (ResidueColourScheme) sg.cs;
      rcs.setThreshold(0);
      sg.cs = rcs;
    }

    refresh();

  }


  protected void userDefinedColour_actionPerformed(ActionEvent e)
  {
    UserDefinedColours chooser = new UserDefinedColours( ap, getGroup());
  }

  protected void PIDColour_actionPerformed(ActionEvent e)
  {

  }

  protected void BLOSUM62Colour_actionPerformed(ActionEvent e)
  {
    SequenceGroup sg = getGroup();

    sg.cs = new Blosum62ColourScheme();

    sg.cs.setConsensus(AAFrequency.calculate(sg.sequences, 0,
                                               ap.av.alignment.getWidth()));

    refresh();
  }


  protected void noColourmenuItem_actionPerformed(ActionEvent e)
  {
    getGroup().cs = null;
    refresh();
  }

  protected  void conservationMenuItem_actionPerformed(ActionEvent e)
  {
    SequenceGroup sg = getGroup();

    if(conservationMenuItem.getState())
    {

        Conservation c = new Conservation("Group",
                                          ResidueProperties.propHash, 3,
                                          sg.sequences, 0,
                                          ap.av.alignment.getWidth());

        c.calculate();
        c.verdict(false, ap.av.ConsPercGaps);
        ConservationColourScheme ccs = new ConservationColourScheme(c, sg.cs);


      sg.cs = ccs;

      SliderPanel.setConservationSlider(ap, ccs, sg.getName());
      SliderPanel.showConservationSlider();
    }
    else // remove ConservationColouring
    {
        ConservationColourScheme ccs = (ConservationColourScheme)sg.cs;
        sg.cs = ccs.cs;
    }

     refresh();
  }

  protected void groupAnnotation_actionPerformed(ActionEvent e)
  {

  }

  protected void groupName_actionPerformed(ActionEvent e)
  {
  /*  SequenceGroup sg = getGroup();
    String reply = JOptionPane.showInternalInputDialog(Desktop.desktop, "Enter new group name", "Edit group name", JOptionPane.QUESTION_MESSAGE);
    if(reply==null)
      return;

    sg.setName(reply);
    groupName.setLabel(reply);*/
  }


  protected void analyze_actionPerformed(ActionEvent e)
  {
     CutAndPasteTransfer cap = new CutAndPasteTransfer(false);
     Frame frame = new Frame();
     frame.add(cap);
     jalview.bin.JalviewLite.addFrame(frame, "Analyze this - ", 400, 300);
     SequenceGroup sg = getGroup();
     StringBuffer sb = new StringBuffer();

     for(int i=0; i<sg.sequences.size(); i++)
     {
       Sequence tmp = (Sequence)sg.sequences.elementAt(i);
       sb.append(  tmp.getSequence(sg.getStartRes(), sg.getEndRes()+1));
       sb.append("\n");
     }

     sb.append("Something amazing will happen soon");
     cap.setText( sb.toString() );

  }

  SequenceGroup getGroup()
  {
    SequenceGroup sg = ap.av.getSelectionGroup();

    // this method won't add a new group if it already exists
    ap.av.alignment.addGroup(sg);

    return sg;
  }

  void sequenceName_actionPerformed(ActionEvent e)
  {
  /*  String id = sequence.getName();
    String s = (String)JOptionPane.showInternalInputDialog(
                ap,
                "Edit sequence name",
                "Edit sequence name ("+sequence.getName()+")",
                JOptionPane.PLAIN_MESSAGE,
                null,
                null,
                id);

    if(s!=null)
    {
      sequence.setName(s);
      ap.repaint();
    }*/

  }

  void unGroupMenuItem_actionPerformed(ActionEvent e)
  {
     SequenceGroup sg = ap.av.getSelectionGroup();
     ap.av.alignment.deleteGroup(sg);
     ap.av.setSelectionGroup(null);
     ap.repaint();
  }


  protected void outline_actionPerformed(ActionEvent e)
  {
  /*  SequenceGroup sg = getGroup();
    Color col = JColorChooser.showDialog(this, "Select Outline Colour", Color.BLUE);
    if(col!=null)
      sg.setOutlineColour(col);*/
  }

}
